#!/bin/bash
# This script is used to run the test on the device and collect the logs and the test results.
# Precondition: The device/emulator is connected/running and the test application is installed on it.

adb shell "run-as io.qt.qtuiviewer.test rm -rf /data/data/io.qt.qtuiviewer.test/files/output.junitxml"
adb shell am start -e applicationArguments "'-o output.junitxml,junitxml -v2'" -n io.qt.qtuiviewer.test/org.qtproject.qt.android.bindings.QtActivity

counter=0
while [ -z "$(adb shell pidof -s io.qt.qtuiviewer.test)" ]; do
    echo "Waiting for test to start"
    sleep 0.1
    counter=$((counter + 1))
    if [ $counter -gt 60 ]; then
        echo "Test did not start in time"
        exit 1
    fi
done

PID_OF_TEST=$(adb shell pidof -s io.qt.qtuiviewer.test)
echo "PID of test: ${PID_OF_TEST}"

counter=0
while [ -n "$(adb shell pidof -s io.qt.qtuiviewer.test)" ]; do
    echo "Waiting for test to finish. Elapsed time: $counter seconds"
    sleep 1
    counter=$((counter + 1))
    if [ $counter -gt 300 ]; then
        echo "Test did not finish in time"
        exit 1
    fi
done

adb logcat -d --pid=${PID_OF_TEST}
adb logcat -d --pid=${PID_OF_TEST} >logcat.txt
adb shell "run-as io.qt.qtuiviewer.test cat /data/data/io.qt.qtuiviewer.test/files/output.junitxml" >output.junit.xml
